#include <iostream>
#include <cstdio>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;

int n, q, temp;
struct point
{
    int x;
    int y;
    int id;
};

struct point_cmp { bool operator() (const point& p, const point& q) const { return p.x < q.x || p.x == q.x && (p.y < q.y || p.y == q.y && p.id < q.id); } };

int cid = 1;

point p[300300], cp;
map<pair<int, int>, vector<int>> pid;

map<int, int>xs; int xsn = 1;
map<int, int>ys; int ysn = 1;

vector < set<point, point_cmp> > sx(1);
vector < set<point, point_cmp> > sy(1);

void add_point(int cx, int cy)
{
    pid[pair<int,int>(cx,cy)].push_back(cid);
    cp.x = cx; cp.y = cy; cp.id = cid++;
    temp = xs[cx];
    if(!temp)
    {
        temp = xs[cx] = xsn++;
        sx.push_back(set<point, point_cmp>());
    }
    sx[temp].insert(cp);
    temp = ys[cy];
    if(!temp)
    {
        temp = ys[cy] = ysn++;
        sy.push_back(set<point, point_cmp>());
    }
    sy[temp].insert(cp);
    return;
}

void rem_point(int cx, int cy)
{
    int temp = pid[pair<int,int>(cx,cy)].back();
    point cp; cp.x = cx; cp.y = cy; cp.id = temp;
    pid[pair<int,int>(cx,cy)].pop_back();
    sx[xs[cx]].erase(cp);
    sy[ys[cy]].erase(cp);
    return;
}

void largest_triangle(int cx, int cy)
{
    if (sx[xs[cx]].empty() || sy[ys[cy]].empty()) { cout << "0\n"; return; }
    long long ans = (long long)max(cy - (*sx[xs[cx]].begin()).y, (*sx[xs[cx]].rbegin()).y - cy) * (long long)max(cx - (*sy[ys[cy]].begin()).x, (*sy[ys[cy]].rbegin()).x - cx);
    cout << ans / 2 << (ans % 2 ? ".5\n" : "\n");
    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    //freopen("triangle00.in","r",stdin);
    //freopen("triangle00.sol","w",stdout);

    cin >> n >> q;
    int co, cx, cy;
    for (int i = 0; i < n; ++i)
    {
        cin >> cx >> cy;
        add_point(cx, cy);
    }
    for (int i = 0; i < q; ++i)
    {
        cin >> co >> cx >> cy;
        if (co == 1) add_point(cx, cy);
        if (co == 2) rem_point(cx, cy);
        if (co == 3) largest_triangle(cx, cy);
    }

    return 0;
}
/*
5 100
0 5
0 -3
5 5
2 3
10 0
*/
